$(document).ready(function()
{
    $('[placeholder]').placeholder();

    $('.e-order-item-name').click(function(e)
    {
        e.preventDefault();

        var $self = $(this);
        $self.toggleClass('e-order-item-name_expanded');
        $self.closest('.b-orders-item').toggleClass('b-orders-item_expanded').find('.b-order-item-content').slideToggle();
    });

    $('.b-tabbed-head-item').click(function(e)
    {
        e.preventDefault();

        var $self = $(this);
        if($self.is('.b-tabbed-head-item_active'))
        {
            return;
        }

        $self.addClass('b-tabbed-head-item_active').siblings().removeClass('b-tabbed-head-item_active');;
        var $target = $($self.attr('href'));
        $target.addClass('b-tabbed-pages-item_active').siblings().removeClass('b-tabbed-pages-item_active');
    });

    $('.b-form input[type=radio]').niceRadio();

    $('.b-back-call-title').click(function(e)
    {
        e.preventDefault();

        var $self = $(this);
        var $parent = $self.closest('.b-back-call');
        $parent.find('.b-back-call-content').slideDown(function(){
            $parent.removeClass('b-back-call_hidden');
        });
    });

    $('.b-promo').each(function(index, element)
    {
        (function($carousel)
        {
            var currentItemIndex = 0;
            var itemsContainer = $carousel.find('.b-promo-items');
            var itemsCount = itemsContainer.children().length;
            var itemsClip = $carousel.find('.b-promo-clip');
            var itemWidth = 700;

            var selectorItemsContainer =  $carousel.find('.b-promo-nav').empty();
            for(var i = 0; i < itemsCount; i++)
            {
                var selectorItem = $('<a href="#" class="b-promo-nav-item"></a>');
                selectorItem.text(i + 1);
                selectorItem.data('element-index', i);
                if(i == 0)
                {
                    selectorItem.addClass('b-promo-nav-item_active');
                }
                selectorItemsContainer.append(selectorItem);
            }

            var slideToItem = function(itemIndex)
            {
                itemsContainer.animate({
                    'left': -itemIndex * itemWidth  + 'px'
                }, function()
                {
                    currentItemIndex = itemIndex;
                    $(selectorItemsContainer.children().removeClass('b-promo-nav-item_active').get(currentItemIndex)).addClass('b-promo-nav-item_active');
                });
            };

            $carousel.find('.b-promo-nav-item').on('click', function(e)
            {
                e.preventDefault();
                var targetElementIndex = $(this).data('element-index');
                slideToItem(targetElementIndex);
            });

            var autoChangeInterval = 15000;
            var autoChangeFunc = function()
            {
                slideToItem((currentItemIndex + 1) % itemsCount);
                window.setTimeout(autoChangeFunc, autoChangeInterval);
            };
            window.setTimeout(autoChangeFunc, autoChangeInterval);
        })($(element));
    });

    $('.b-carousel').each(function(index, element)
    {
        (function($carousel)
        {
            var currentItemIndex = 0;
            var itemsContainer = $carousel.find('.b-carousel-items');
            var itemsCount = itemsContainer.children().length;
            var itemsClip = $carousel.find('.b-carousel-clip');
            var itemWidth = 621;
            var $prev = $carousel.find('.b-carousel-action_prev');
            var $next = $carousel.find('.b-carousel-action_next');

            var slideToItem = function(itemIndex)
            {
                itemsContainer.animate({
                    'left': -itemIndex * itemWidth + 'px'
                }, function()
                {
                    currentItemIndex = itemIndex;
                });
            };

            $prev.click(function(e)
            {
                e.preventDefault();

                slideToItem((currentItemIndex - 1) < 0 ? 0 : currentItemIndex - 1);
            });
            $next.click(function(e)
            {
                e.preventDefault();

                slideToItem((currentItemIndex + 1) % itemsCount);
            });
        })($(element));
    });

    $('.b-product-carousel').each(function(index, element)
    {
        (function($carousel)
        {
            var currentItemIndex = 0;
            var itemsContainer = $carousel.find('.b-product-carousel__items');
            var itemsCount = itemsContainer.children().length;
            var itemsClip = $carousel.find('.b-product-carousel__clip');
            var itemWidth = 690;
            var $prev = $carousel.find('.b-product-carousel__action_prev');
            var $next = $carousel.find('.b-product-carousel__action_next');

            var slideToItem = function(itemIndex)
            {
                itemsContainer.animate({
                    'left': -itemIndex * itemWidth + 'px'
                }, function()
                {
                    currentItemIndex = itemIndex;
                });
            };

            $prev.click(function(e)
            {
                e.preventDefault();

                slideToItem((currentItemIndex - 1) < 0 ? 0 : currentItemIndex - 1);
            });
            $next.click(function(e)
            {
                e.preventDefault();

                slideToItem((currentItemIndex + 1) % itemsCount);
            });
        })($(element));
    });

    $('.b-office-map').each(function(index, element)
    {
        var $element = $(element);

        var lat = $element.data('center-lat');
        var lng = $element.data('center-lng');
        var marker = $element.data('marker');

        var latLng = new google.maps.LatLng(lat, lng);
        var map_canvas = $element.get(0);
        var map_options = {
            center: latLng,
            zoom: 16,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }
        var map = new google.maps.Map(map_canvas, map_options);

        var marker = new google.maps.Marker({
            position: latLng,
            map: map,
            title: marker
        });
    });

    $('.b-to-get-scheme').click(function(e)
    {
        e.preventDefault();
        var $mapContainer = $(this).closest('.b-to-get').find('.b-to-get-map');

        $mapContainer.slideDown(function()
        {
            var $element = $mapContainer.find('.b-to-get-map-inner');

            var lat = $element.data('center-lat');
            var lng = $element.data('center-lng');
            var marker = $element.data('marker');

            var latLng = new google.maps.LatLng(lat, lng);
            var map_canvas = $element.get(0);
            var map_options = {
                center: latLng,
                zoom: 16,
                mapTypeId: google.maps.MapTypeId.ROADMAP
            }
            var map = new google.maps.Map(map_canvas, map_options);

            var marker = new google.maps.Marker({
                position: latLng,
                map: map,
                title: marker
            });
        });
    });

    $('.b-popup').hide();
    $('.b-overlay').hide();

    var popupOpen = false;
    var hidePopups = function()
    {
        if(!popupOpen)
        {
            return;
        }
        $('#overlay').hide();
        $('.l-wrapper, .l-footer')
            .detach()
            .prependTo('body');
        if($('.b-content-wrapper').length)
        {
            var scroll = $('.b-content-wrapper').data('scroll');
        }
        $('.b-content-wrapper').remove();

        $('.b-popup')
            .detach()
            .appendTo('body');
        $('.b-popup-wrapper').remove();
        $('.b-popup').hide();
        if(scroll)
        {
            $(window).scrollTop(scroll);
        }
        popupOpen = false;
    };

    $('body').click(function(e)
    {
        if(popupOpen)
        {
            if(!$(e.target).is('.b-popup, .b-popup *, .e-popup-trigger, .e-popup-trigger *, .e-dont-close, .e-dont-close *'))
            {
                hidePopups();
            }
        }
    });
    $('.b-popup-head-close, .e-popup-close').bind('click', function(e)
    {
        e.preventDefault();
        hidePopups();
    });

    var popupPositionStrategies = {
        'center': function(trigger, popup, parameters)
        {
            if(popup.outerHeight() < $(window).height())
            {
                popup.css({
                    'margin-top': ($(window).height() - popup.outerHeight()) / 2
                });
            }
            else
            {
                popup.css({
                    'margin': '30px 0'
                });
            }
            popup.css({
                'display': 'inline-block',
                'zoom': '1',
                'position': 'relative'
            })
        },
        'relative': function(trigger, popup, parameters)
        {
            var triggerPosition = trigger.offset();
            var popupStyle = {
                'top': triggerPosition.top + trigger.height() + parameters.top,
                'left': triggerPosition.left + trigger.outerWidth() - parameters.right - popup.outerWidth(),
                'margin-top': 0,
                'margin-left': 0
            };
            popup.css(popupStyle);
        }
    };

    var showPopup = function(id, trigger, popupParameters)
    {
        hidePopups();

        popupParameters = popupParameters || {};
        var $popup = $(id);
        if($popup.length != 1)
        {
            return;
        }

        var positionStrategyName = popupParameters['position'] || 'center';
        var positionStrategy = popupPositionStrategies[positionStrategyName];
        if(!positionStrategy)
        {
            return;
        }
        positionStrategy(trigger, $popup, popupParameters);

        if(popupParameters['showOverlay'])
        {
            $('#overlay').show();
        }
        hidePopups();

        var $contentWrapper = $('<div class="b-content-wrapper"></div>').css({
            'top': -$(window).scrollTop()
        }).data('scroll', $(window).scrollTop());
        $('.l-wrapper, .l-footer')
            .detach()
            .appendTo($contentWrapper);
        $('body').append($contentWrapper);
        $popup.wrap('<div class="b-popup-wrapper"></div>');

        $popup.css({
            'display': 'inline-block'
        });
        $(window).scrollTop(0);
        popupOpen = true;
    };

    $('.e-popup-trigger').bind('click', function(e)
    {
        e.preventDefault();

        var $this = $(this);
        var popupParameters = {
            'position': $this.data('popup-position'),
            'top': $this.data('popup-top'),
            'right': $this.data('popup-right'),
            'showOverlay': $this.data('show-overlay')
        };

        showPopup($this.attr('href'), $this, popupParameters);
    });

    //showPopup('#popup-reg');

    var $carouselImages = $('.b-carousel-image');
    if($carouselImages.length)
    {
        $carouselImages.attr('rel', 'gallery').fancybox({
            'padding': 20
        });
    }

    $('.b-filter-title-text, .b-side-menu-title-text').click(function(e)
    {
        var $filterContent = $('.b-filter-content');
        var $sideMenuContent = $('.b-side-menu-content');

        if($filterContent.is(':visible'))
        {
            $filterContent.slideUp(function(){$('.b-filter').removeClass('b-filter_open')});
            $sideMenuContent.slideDown(function(){$('.b-side-menu').addClass('b-side-menu_open')});
        }
        else
        {
            $filterContent.slideDown(function(){$('.b-filter').addClass('b-filter_open')});
            $sideMenuContent.slideUp(function(){$('.b-side-menu').removeClass('b-side-menu_open')});
        }
    });
    $('.b-filter-param-title').click(function(e)
    {
        e.preventDefault();

        $(this).parent().find('.b-filter-param-items').slideToggle();
    });

    $('.b-password-reset input[type=checkbox]').niceCheckbox();

    $('.b-password-reset a').click(function(e) {
        e.preventDefault();
        $(this).siblings('.e-checkbox-replacement').click();
    });
    $('.b-radio a').click(function(e) {
        e.preventDefault();
        $(this).siblings('.e-radio-replacement').click();
    });

    $('.e-trigger').click(function(e) {
        var $target = $($(this).data('target'));
        $target.toggle();
    });

    $('.b-radio-list-sub').hide();
    $('.b-radio_trigger-sub').each(function(i,e) {
        var $self = $(e);
        setInterval(function(){
            if($self.find('input[type=radio]').is(':checked')) {
                $self.next('.b-radio-list-sub').show();
            }
            else {
                $self.next('.b-radio-list-sub').hide();
            }
        },100);
    });

    $('.b-radio-variant-desc').hide();
    $('.b-radio input[type=radio][data-toggle]').each(function(i,e) {
        var $self = $(e);
        setInterval(function(){
            if($self.is(':checked')) {
                $($self.data('toggle')).show();
            }
            else {
                $($self.data('toggle')).hide();
            }
        }, 100);
    });

    $('.b-checkout-address').hide();

    var updateAddress = function() {
        var shipping = $('input[name=shipping]:checked').val();
        var type = $('input[name=type]:checked').val();
        var typeLegal = (type == 'legal');
        var showAddress = shipping == 'taxi' || shipping == 'biz-lines' || typeLegal;
        if(showAddress) {
            $('.b-checkout-address').show();
        }
        else {
            $('.b-checkout-address').hide();
        }

        if(shipping == 'pickup') {
            $('.i-person-only').hide();
        }
        else {
            $('.i-person-only').show();
        }
    };
    $('input[name=shipping]').change(function(e){
        updateAddress();
    });

    $('.b-payment_legal').hide();
    $('input[name=type]').change(function(e) {
        var $self = $(this);
        var type = $self.val();

        updateAddress();

        if(type == 'legal') {
            $('.b-payment_person').hide();
            $('.b-payment_legal').show();
            $('input[name=payment][value=beznal]').click();
        }
        else {
            $('.b-payment_person').show();
            $('.b-payment_legal').hide();
            $('input[name=payment][value=visa]').click();
        }
    });

    $('.b-compare__content').each(function(index, element) {
        var $compare = $(element);

        var $clip = $compare.find('.b-compare-clip');
        var $pane = $compare.find('.b-compare-clip__pane');
        var $bar = $compare.find('.b-compare-scroll-bar');
        var $handle = $compare.find('.b-compare-scroll-bar__handle');

        var barWidth = $bar.width();
        var paneWidth = $pane.width();
        var clipWidth = $clip.width();
        var handleWidth = clipWidth * barWidth / paneWidth;
        $handle.css({
            'width': handleWidth + 'px',
            'left': '0px'
        });

        var isHandleDragging = false;
        var mouseLastPosition = null;

        var onScroll = function(currentPosition) {
            var mouseMovement = currentPosition - mouseLastPosition;
            if(mouseMovement == 0) {
                return;
            }

            var currentHandlePosition = $handle.position().left;
            var finalHandlePosition = Math.min(barWidth - handleWidth, Math.max(currentHandlePosition + mouseMovement, 0));

            var paneMovement = -1 * finalHandlePosition * paneWidth / barWidth;
            $handle.css({
                'left': finalHandlePosition + 'px'
            });
            $pane.css({
                'left': paneMovement + 'px'
            });

            mouseLastPosition = currentPosition;
        };

        $handle.on('mousedown', function(e) {
            isHandleDragging = true;
            mouseLastPosition = e.pageX;
        });
        $('body').on('mouseup', function(e) {
            if(isHandleDragging) {
                isHandleDragging = false;
                onScroll(e.pageX);
            }
        });
        $('body').on('mousemove', function(e) {
            if(isHandleDragging) {
                onScroll(e.pageX);
            }
        });
    });

    $('.b-cart-info-label').click(function(e) {
        e.preventDefault();

        $(this).closest('.b-cart-info').find('.b-cart-info-details').toggle();
    });
});